package yhg.comm.client;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.net.UnknownHostException;

import yhg.comm.message.Message;

/**
 * Ŭ̾Ʈ
 * 
 * @author	Yoon HyunGook
 * @since	2010-03-08
 */
public class CommClient extends Thread {
	private Socket sock;
	private ObjectOutputStream out;
	private ObjectInputStream in;
	private ICommClientEvent clientEvent;

	/**
	 * 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	 ּ
	 * @param	 Ʈ
	 */
	public CommClient(String address, int port) throws UnknownHostException, IOException{
		sock = new Socket(address,port);
		
		out = new ObjectOutputStream(sock.getOutputStream());
		in = new ObjectInputStream(sock.getInputStream());
	}
	
	/**
	 *  Run
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 */
	public void run(){
		Message msg = null;
		
		try {
			while((msg = (Message)in.readObject()) != null){
				clientEvent.onReceiveMessage(msg);
			}
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 *  ޼ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	޼
	 */
	public void send(Message msg) throws IOException{
		out.writeObject(msg);
	}
	
	/**
	 *   
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @return	
	 */
	public Socket getSocket(){
		return sock;
	}
	
	/**
	 * ̺Ʈ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	Ŭ̾Ʈ ̺Ʈ
	 */
	public void setClientEvent(ICommClientEvent evt){
		this.clientEvent = evt;
	}
}
