package yhg.comm.server;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.InetAddress;
import java.net.Socket;

import yhg.comm.message.Message;

/**
 *   Ŭ̾Ʈ ϴ Ŭ
 * 
 * @author	Yoon HyunGook
 * @since	2010-03-08
 */
public class CommClientManager extends Thread {
	private Socket sock;
	private ObjectInputStream in;
	private ObjectOutputStream out;
	private ICommClientManagerEvent cmEvent;
	private CommServer server;
	private InetAddress address;
	private int number;
	
	/**
	 * 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	Ŭ̾Ʈ 
	 */
	public CommClientManager(CommServer server, Socket sock, int num) throws IOException{
		this.sock = sock;
		this.server = server;
		this.number = num;
		in = new ObjectInputStream(sock.getInputStream());
		out = new ObjectOutputStream(sock.getOutputStream());
		address = sock.getLocalAddress();
	}
	
	/**
	 * ̺Ʈ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	̺Ʈ
	 */
	protected void setClientManagerEvent(ICommClientManagerEvent evt){
		this.cmEvent = evt;
	}
	
	/**
	 *  
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 */
	public void run(){
		Message msg = null;
		
		try {
			while((msg = (Message) in.readObject()) != null){
				cmEvent.onReceiveMessage(this, msg);
			}
		} catch (IOException e) {
		} catch (ClassNotFoundException e) {
		} finally{
			try {
				in.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
			
			server.onLeaveClient(this);
		}
	}
	
	/**
	 * ϴ Ŭ̾Ʈ ޼ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	޼
	 */
	public void send(Message msg) throws IOException{
		out.writeObject(msg);
		cmEvent.onSendMessage(this, msg);
	}
	
	/**
	 * Ŭ̾Ʈ  
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @return	
	 */
	public Socket getSocket(){
		return sock;
	}
	
	/**
	 * Ŭ̾Ʈ ּ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @return	Ŭ̾Ʈ ּ
	 */
	public InetAddress getLocalAddress(){
		return address;
	}
	
	/**
	 * Ŭ̾Ʈ ȣ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-10
	 * 
	 * @return	Ŭ̾Ʈ ȣ
	 */
	public int getNumber(){
		return number;
	}
}
